<template>
  <apexchart
    ref="barChartJobsExecuted"
    height="350px"
    :options="chartOptions"
    :series="series" />
</template>

<script>
import VueApexCharts from 'vue3-apexcharts'

const conf = config()

export default {
  props: {
     dt_to: {type: String},
     dt_from: {type: String}
  },
  components: {
    apexchart: VueApexCharts
  },
  data () {
    return {
      filters: undefined,
      series: [],
      chartOptions: {
            noData: {
              text: "No data found yet for the period."
            },
            colors: ['#f2c037', '#21ba45', '#c10015', '#26a69a'],
            chart: {
                type: 'bar',
                stacked: true,
                toolbar: {
                  show: true,
                },
                zoom: {
                  autoScaleYaxis: false // apexcharts-- there is a bug with this.
                },
            },
            dataLabels: {
                enabled: false
            },
            plotOptions: {
               bar: { horizontal: false, columnWidth: '30%' },
            },
            legend: { position: 'top', horizontalAlign: 'center' },
            title: {
                text: "Pipelines executed",
                style: {
                   fontSize: '16px'
                }
            },
            subtitle: {
                text: "Each bar is a pipeline executed with their tests inside."
            },
            fill: {
                opacity: 1
            },
            yaxis: {
               decimalsInFloat: 2,
               forceNiceScale: true,
            },
            xaxis: {
               type: "category",
               // type: "datetime",
                labels: {
                   hideOverlappingLabels: true,
                   show: true,
                   rotate: 0,
                   format: 'dd/MM',
                   formatter: function( value )  {
                     return value.toString().substr(0,10)
                   },
                   datetimeFormatter: {
                     year: 'yyyy',
                     month: 'MMM \'yy',
                     day: 'dd MMM',
                     hour: 'HH:mm'
                   }
                }
            },

            tooltip: {
               shared: true,
               intersect: false,
               enabled: true,
            }
      } 
    }
  },
  created() {
    this.filters = {'dt_from': this.dt_from, 'dt_to': this.dt_to}
    this.fetchData()
    this.emitter.on('project.filter.applied', (event_data) => {
      this.filters = event_data
      this.fetchData()
    })
  },
  computed: {
    pipelines_endpoint() {
       let project_id = this.$route.params.id
       let endpoint = conf.I4C_API_SERVER + "/projects/" + project_id + "/pipelines"
       if (this.filters == null) {
           console.log("Filter is undefined, getting all tests...")
           return endpoint
       }

       console.log("Filter is defined:", this.filters)

       let dt_from = encodeURIComponent(this.filters.dt_from)
       let dt_to = encodeURIComponent(this.filters.dt_to)
       let in_groups = encodeURIComponent(this.filters.in_groups)
       let query = "?dt_from=" + dt_from + "&dt_to=" + dt_to + "&in_groups=" + in_groups

       return endpoint + query
    }
  },
  methods: {
    fetchData () {
       console.log("FetchData called")
       this.series = []
       fetch(this.pipelines_endpoint)
         .then(response => response.json())
         .then(data => (this.update(data)))
    },
    update (pipelines) {
      console.log("Updating...", pipelines)
      if (pipelines === undefined) {
         return
      }
         
      let results = {'failed': [],
                     'success': [],
                     'error': [],
                     'skipped': [],
                     'canceled': [],
                     'manual': []}

      let series = []
      let categories = []

      pipelines.forEach(function(pipeline) {
        // let created_at = new Date(pipeline.created_at).getTime()
        categories.unshift(pipeline.created_at)

        results['failed'].push(pipeline.tests_stats['failed'])
        results['success'].push(pipeline.tests_stats['success'])
        results['error'].push(pipeline.tests_stats['error'])
        results['skipped'].push(pipeline.tests_stats['skipped'])
        results['canceled'].push(pipeline.tests_stats['canceled'])
      })

      const keys = ['failed', 'success', 'error', 'skipped', 'canceled']
      keys.forEach(function (key) {
          series.push({'name': key, 'data': results[key]})
      })
      this.series = series
      this.chartOptions.xaxis['categories'] = categories
      this.$refs.barChartJobsExecuted.updateOptions(this.chartOptions)
      this.$refs.barChartJobsExecuted.updateSeries(this.series)
    }
  }
}
</script>

<style>

.apexcharts-marker {
  stroke-width: 1px;
}

</style>
